import mechanize
import time
from lxml.html import parse, etree

def log():
    resp = br.response()
    code = resp.getcode()
    if br.viewing_html():
        print(f"{code} - {br.title()}")
    else:
        print(f"{code} - Not Html")

def next_button_predicate(x):
    #[('class', 'button button-icon-only'), ('href', './ucp.php?i=pm&mode=view&action=view_folder&f=0&st=0&sk=t&sd=d&start=50'), ('rel', 'next'), ('role', 'button')]
    points = 0
    for a in x.attrs:
        if a[0] == 'class':
            if "button" in a[1]:
                points += 1
        if a[0] == 'rel':
            if a[1] == 'next':
                points += 1
    return points >= 2



br = mechanize.Browser()
br.set_handle_robots(False)
br.open("https://deskthority.net/")
log()

br.follow_link(text="Login")
log()

br.select_form(id="login")
br["username"] = input("user: ")
br["password"] = input("password: ")
time.sleep(1)
br.submit()
log()

br.follow_link(text_regex="Private\s*messages")
log()

page = parse(br.response())
folder_links = page.findall('//div[@id="navigation"]//a[@href]')
links = []
for l in folder_links:
    href = l.attrib['href']
    if "folder=" in href:
        links.append(href)

for link in links:
    br.open(link)
    log()
    
    fname = link.split("folder=")[1].split("&")[0]
    print(f'Deleting folder {fname}')
    #if fname == "outbox":
    #    print("skipping")
    #    continue

    try:
        while True:
            page = parse(br.response())
            pagenoel = page.find('//div[@class="pagination"]//li[@class="active"]')
            onepage = False
            if pagenoel is None:
                print(f"Deleting only one page")
                pageno = "1"
                onepage = True
            else:
                pageno = etree.tostring(pagenoel, method="text").strip().decode('utf-8')
                print(f"Deleting page {pageno}")
            #print(page.findall('//input[@name="marked_msg_id[]"]'))

            br.select_form(id="viewfolder")
            for i in br.find_control(type="checkbox", name="marked_msg_id[]").items:
                i.selected=True
            br["mark_option"] = ["delete_marked",]
            time.sleep(0.2)
            r = br.submit(nr=1)
            log()

            #print(br.response().read())

            br.select_form(id="confirm")
            time.sleep(0.2)
            br.submit(nr=0)

            #time.sleep(1)
            br.back()
            #time.sleep(1)
            br.back()

            if onepage:
                break

            br.reload()

            #br.follow_link(predicate=next_button_predicate)
            log()
    except mechanize.LinkNotFoundError:
        print("Last page reached")
        pass
